import _extends from "@babel/runtime/helpers/esm/extends";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";

function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

import { prepareEvents } from './prepare-events';
export var getEventStore = function getEventStore(events, context) {
  var eventStoreLocalState = new Map();
  return {
    loadEvents: function () {
      var _loadEvents = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.t0 = prepareEvents(events, context);
                return _context.abrupt("return", {
                  events: _context.t0,

                  get cursor() {
                    throw new Error('Cursor access violation');
                  }

                });

              case 2:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      function loadEvents() {
        return _loadEvents.apply(this, arguments);
      }

      return loadEvents;
    }(),
    ensureEventSubscriber: function () {
      var _ensureEventSubscriber = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(_ref) {
        var applicationName, eventSubscriber, destination, status;
        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                applicationName = _ref.applicationName, eventSubscriber = _ref.eventSubscriber, destination = _ref.destination, status = _ref.status;
                eventStoreLocalState.set("" + applicationName + eventSubscriber, _extends({}, eventStoreLocalState.has("" + applicationName + eventSubscriber) ? eventStoreLocalState.get("" + applicationName + eventSubscriber) : {}, destination != null ? {
                  destination: destination
                } : {}, status != null ? {
                  status: status
                } : {}));

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function ensureEventSubscriber(_x) {
        return _ensureEventSubscriber.apply(this, arguments);
      }

      return ensureEventSubscriber;
    }(),
    removeEventSubscriber: function () {
      var _removeEventSubscriber = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee3(_ref2) {
        var applicationName, eventSubscriber;
        return _regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                applicationName = _ref2.applicationName, eventSubscriber = _ref2.eventSubscriber;
                eventStoreLocalState["delete"]("" + applicationName + eventSubscriber);

              case 2:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3);
      }));

      function removeEventSubscriber(_x2) {
        return _removeEventSubscriber.apply(this, arguments);
      }

      return removeEventSubscriber;
    }(),
    getEventSubscribers: function () {
      var _getEventSubscribers = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee4(_temp) {
        var _ref3, applicationName, eventSubscriber, result, _iterator, _step, _step$value, key, _step$value$, destination, status;

        return _regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _ref3 = _temp === void 0 ? {} : _temp, applicationName = _ref3.applicationName, eventSubscriber = _ref3.eventSubscriber;

                if (!(applicationName == null && eventSubscriber == null)) {
                  _context4.next = 3;
                  break;
                }

                return _context4.abrupt("return", [].concat(eventStoreLocalState.values()));

              case 3:
                result = [];

                for (_iterator = _createForOfIteratorHelperLoose(eventStoreLocalState.entries()); !(_step = _iterator()).done;) {
                  _step$value = _step.value, key = _step$value[0], _step$value$ = _step$value[1], destination = _step$value$.destination, status = _step$value$.status;

                  if ("" + applicationName + eventSubscriber === key) {
                    result.push({
                      applicationName: applicationName,
                      eventSubscriber: eventSubscriber,
                      destination: destination,
                      status: status
                    });
                  }
                }

                return _context4.abrupt("return", result);

              case 6:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4);
      }));

      function getEventSubscribers(_x3) {
        return _getEventSubscribers.apply(this, arguments);
      }

      return getEventSubscribers;
    }(),
    getNextCursor: function () {
      var _getNextCursor = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee5() {
        return _regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                return _context5.abrupt("return", 'SHIFT_CURSOR');

              case 1:
              case "end":
                return _context5.stop();
            }
          }
        }, _callee5);
      }));

      function getNextCursor() {
        return _getNextCursor.apply(this, arguments);
      }

      return getNextCursor;
    }(),
    loadSnapshot: function () {
      var _loadSnapshot = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee6() {
        return _regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                return _context6.abrupt("return", null);

              case 1:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6);
      }));

      function loadSnapshot() {
        return _loadSnapshot.apply(this, arguments);
      }

      return loadSnapshot;
    }(),
    saveEvent: function () {
      var _saveEvent = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee7() {
        return _regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                return _context7.abrupt("return", void 0);

              case 1:
              case "end":
                return _context7.stop();
            }
          }
        }, _callee7);
      }));

      function saveEvent() {
        return _saveEvent.apply(this, arguments);
      }

      return saveEvent;
    }(),
    saveSnapshot: function saveSnapshot() {
      return void 0;
    }
  };
};
//# sourceMappingURL=get-event-store.js.map