import _extends from "@babel/runtime/helpers/esm/extends";
export var prepareEvents = function prepareEvents(events, context) {
  var timestamp = 1;
  var aggregateVersionsMap = new Map();
  var threadCountersMap = new Map();
  return events.map(function (testEvent) {
    var aggregateId = testEvent.aggregateId != null ? testEvent.aggregateId : context == null ? void 0 : context.aggregateId;
    var aggregateVersion = aggregateVersionsMap.has(aggregateId) ? aggregateVersionsMap.get(aggregateId) + 1 : 1;
    var threadId = Buffer.from(JSON.stringify(testEvent)).reduce(function (acc, val) {
      return (acc + val) % 256;
    }, 0);
    var threadCounter = threadCountersMap.has(threadId) ? threadCountersMap.get(threadId) + 1 : 1;

    var event = _extends({}, testEvent, {
      aggregateId: aggregateId,
      aggregateVersion: aggregateVersion,
      timestamp: timestamp++,
      threadId: threadId,
      threadCounter: threadCounter
    });

    aggregateVersionsMap.set(aggregateId, aggregateVersion);
    threadCountersMap.set(threadId, threadCounter + 1);
    return event;
  });
};
//# sourceMappingURL=prepare-events.js.map